import { Canvas, ComputedCamera, Pen, SerializedNode, CheckboardStyle, API, Task, StateManagement, Commands } from '@infinite-canvas-tutorial/ecs';
import { type LitElement } from 'lit';
/**
 * Since the canvas is created in the system, we need to store them here for later use.
 */
export declare const pendingCanvases: {
    container: LitElement;
    canvas: Partial<Canvas>;
    camera: Partial<ComputedCamera>;
}[];
/**
 * Emit CustomEvents for the canvas.
 */
export declare class ExtendedAPI extends API {
    element: LitElement;
    constructor(stateManagement: StateManagement, commands: Commands, element: LitElement);
    resizeCanvas(width: number, height: number): void;
    setCheckboardStyle(checkboardStyle: CheckboardStyle): void;
    setPen(pen: Pen): void;
    setTaskbars(selected: Task[]): void;
    selectNodes(selected: SerializedNode[], preserveSelection?: boolean): void;
    updateNodes(nodes: SerializedNode[]): void;
    deleteNodesById(ids: SerializedNode['id'][]): SerializedNode[];
    /**
     * Delete Canvas component
     */
    destroy(): void;
}
