import { ContextProvider } from '@lit/context';
import { SerializedNode, AppState, DefaultStateManagement } from '@infinite-canvas-tutorial/ecs';
import { ExtendedAPI } from './API';
export declare const appStateContext: {
    __context__: AppState;
};
export declare const nodesContext: {
    __context__: SerializedNode[];
};
export declare const apiContext: {
    __context__: ExtendedAPI;
};
/**
 * Delegate the methods to the LitElement's context which will trigger re-rendering.
 */
export declare class LitStateManagement extends DefaultStateManagement {
    private readonly appStateProvider;
    private readonly nodesProvider;
    constructor(appStateProvider: ContextProvider<{
        __context__: AppState;
    }>, nodesProvider: ContextProvider<{
        __context__: SerializedNode[];
    }>);
    getAppState(): AppState;
    setAppState(appState: AppState): void;
    getNodes(): SerializedNode[];
    setNodes(nodes: SerializedNode[]): void;
    onChange(snapshot: {
        appState: AppState;
        nodes: SerializedNode[];
    }): void;
}
