var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, css, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { consume } from '@lit/context';
import { apiContext, appStateContext } from '../context';
import { ColorType } from './color-picker';
let StrokeActionButton = class StrokeActionButton extends LitElement {
    handleStrokeChanged(e) {
        const { type, value } = e.detail;
        this.api.updateNode(this.node, {
            stroke: type === 'solid'
                ? value.startsWith('#')
                    ? value
                    : `#${value}`
                : value,
        });
        this.api.record();
    }
    render() {
        const { stroke } = this.node;
        return html `<sp-action-button quiet size="m" id="stroke">
        <ic-spectrum-stroke-icon
          value=${stroke}
          slot="icon"
        ></ic-spectrum-stroke-icon>
        <sp-tooltip self-managed placement="bottom"> Stroke </sp-tooltip>
      </sp-action-button>
      <sp-overlay trigger="stroke@click" placement="bottom" type="auto">
        <sp-popover dialog>
          <ic-spectrum-color-picker
            value=${stroke}
            .types=${[ColorType.None, ColorType.Solid]}
            @color-change=${this.handleStrokeChanged}
          ></ic-spectrum-color-picker>
        </sp-popover>
      </sp-overlay>`;
    }
};
StrokeActionButton.styles = css `
    ic-spectrum-stroke-icon {
      width: 30px;
      height: 30px;
    }

    sp-popover {
      padding: 0;
    }
  `;
__decorate([
    consume({ context: appStateContext, subscribe: true })
], StrokeActionButton.prototype, "appState", void 0);
__decorate([
    consume({ context: apiContext, subscribe: true })
], StrokeActionButton.prototype, "api", void 0);
__decorate([
    property()
], StrokeActionButton.prototype, "node", void 0);
StrokeActionButton = __decorate([
    customElement('ic-spectrum-stroke-action-button')
], StrokeActionButton);
export { StrokeActionButton };
//# sourceMappingURL=stroke-action-button.js.map