var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ZoomLevel_zoomEvent;
import { Camera, Canvas, ComputedCamera, System, Transform, } from '@infinite-canvas-tutorial/ecs';
import { Event } from '../event';
export class ZoomLevel extends System {
    constructor() {
        super();
        _ZoomLevel_zoomEvent.set(this, void 0);
        this.cameras = this.query((q) => q.changed.with(ComputedCamera).trackWrites);
        this.query((q) => q.using(Camera, Transform).write.and.using(Canvas).read);
    }
    initialize() {
        __classPrivateFieldSet(this, _ZoomLevel_zoomEvent, new CustomEvent(Event.ZOOM_CHANGED, {
            detail: {
                zoom: undefined,
            },
            bubbles: true,
            composed: true,
        }), "f");
    }
    execute() {
        this.cameras.changed.forEach((camera) => {
            const { canvas } = camera.read(Camera);
            const api = canvas.read(Canvas).api;
            const { zoom, x, y, rotation } = camera.read(ComputedCamera);
            api.setAppState(Object.assign(Object.assign({}, api.getAppState()), { cameraZoom: zoom, cameraX: x, cameraY: y, cameraRotation: rotation }));
            if (zoom !== __classPrivateFieldGet(this, _ZoomLevel_zoomEvent, "f").detail.zoom) {
                __classPrivateFieldGet(this, _ZoomLevel_zoomEvent, "f").detail.zoom = zoom;
                api.element.dispatchEvent(__classPrivateFieldGet(this, _ZoomLevel_zoomEvent, "f"));
            }
        });
    }
}
_ZoomLevel_zoomEvent = new WeakMap();
//# sourceMappingURL=ZoomLevel.js.map