"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UIPlugin = void 0;
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
const systems_1 = require("../systems");
const UIPlugin = () => {
    /**
     * Solve the following error:
     * Uncaught (in promise) p: Multiple component types named o; names must be unique at eG.createSystems
     *
     * Usually, this error is caused when the code is bundled.
     */
    Object.defineProperty(systems_1.InitCanvas, 'name', {
        value: 'InitCanvas',
    });
    Object.defineProperty(systems_1.ZoomLevel, 'name', {
        value: 'ZoomLevel',
    });
    Object.defineProperty(systems_1.DownloadScreenshot, 'name', {
        value: 'DownloadScreenshot',
    });
    (0, ecs_1.system)((s) => s.after(ecs_1.PreStartUp).before(systems_1.ZoomLevel).beforeWritersOf(ecs_1.Canvas))(systems_1.InitCanvas);
    (0, ecs_1.system)((s) => s
        .inAnyOrderWithWritersOf(ecs_1.Camera)
        .after(ecs_1.SetupDevice, ecs_1.SyncSimpleTransforms, ecs_1.PropagateTransforms, ecs_1.ComputeBounds))(systems_1.ZoomLevel);
    (0, ecs_1.system)((s) => s.before(ecs_1.PreStartUp))(systems_1.DownloadScreenshot);
};
exports.UIPlugin = UIPlugin;
//# sourceMappingURL=UI.js.map