"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Penbar = void 0;
const lit_1 = require("lit");
const decorators_js_1 = require("lit/decorators.js");
const map_js_1 = require("lit/directives/map.js");
const context_1 = require("@lit/context");
const when_js_1 = require("lit/directives/when.js");
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
const context_2 = require("../context");
const PenMap = {
    [ecs_1.Pen.HAND]: {
        icon: (0, lit_1.html) `<sp-icon-hand slot="icon"></sp-icon-hand>`,
        label: 'Hand (Panning tool)',
    },
    [ecs_1.Pen.SELECT]: {
        icon: (0, lit_1.html) `<sp-icon-select slot="icon"></sp-icon-select>`,
        label: 'Select',
    },
    [ecs_1.Pen.DRAW_RECT]: {
        icon: (0, lit_1.html) `<sp-icon-shapes slot="icon"></sp-icon-shapes>`,
        label: 'Shapes',
    },
};
let Penbar = class Penbar extends lit_1.LitElement {
    handlePenChanged(e) {
        this.api.setPen(e.target.selected[0]);
    }
    render() {
        const { penbarAll, penbarSelected, penbarVisible } = this.appState;
        return (0, when_js_1.when)(penbarVisible, () => (0, lit_1.html) `
        <sp-action-group
          class="penbar"
          vertical
          selects="single"
          .selected=${penbarSelected}
          @change=${this.handlePenChanged}
          emphasized
          quiet
        >
          ${(0, map_js_1.map)(penbarAll, (pen) => {
            const { icon, label } = PenMap[pen];
            return (0, lit_1.html) `<sp-action-button value="${pen}">
              ${icon}
              <sp-tooltip self-managed placement="right"> ${label} </sp-tooltip>
            </sp-action-button>`;
        })}
        </sp-action-group>
      `);
    }
};
exports.Penbar = Penbar;
Penbar.styles = (0, lit_1.css) `
    .penbar {
      display: flex;
      justify-content: center;

      background: var(--spectrum-gray-100);
      border-radius: var(--spectrum-corner-radius-200);

      padding: var(--spectrum-global-dimension-size-100);
      margin: 4px;

      filter: drop-shadow(
        var(--spectrum-drop-shadow-color) 0px var(--spectrum-drop-shadow-y)
          var(--spectrum-drop-shadow-blur)
      );
    }
  `;
__decorate([
    (0, context_1.consume)({ context: context_2.appStateContext, subscribe: true })
], Penbar.prototype, "appState", void 0);
__decorate([
    (0, context_1.consume)({ context: context_2.apiContext, subscribe: true })
], Penbar.prototype, "api", void 0);
exports.Penbar = Penbar = __decorate([
    (0, decorators_js_1.customElement)('ic-spectrum-penbar')
], Penbar);
//# sourceMappingURL=penbar.js.map