"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ZoomLevel_zoomEvent;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZoomLevel = void 0;
const ecs_1 = require("@infinite-canvas-tutorial/ecs");
const event_1 = require("../event");
class ZoomLevel extends ecs_1.System {
    constructor() {
        super();
        _ZoomLevel_zoomEvent.set(this, void 0);
        this.cameras = this.query((q) => q.changed.with(ecs_1.ComputedCamera).trackWrites);
        this.query((q) => q.using(ecs_1.Camera, ecs_1.Transform).write.and.using(ecs_1.Canvas).read);
    }
    initialize() {
        __classPrivateFieldSet(this, _ZoomLevel_zoomEvent, new CustomEvent(event_1.Event.ZOOM_CHANGED, {
            detail: {
                zoom: undefined,
            },
            bubbles: true,
            composed: true,
        }), "f");
    }
    execute() {
        this.cameras.changed.forEach((camera) => {
            const { canvas } = camera.read(ecs_1.Camera);
            const api = canvas.read(ecs_1.Canvas).api;
            const { zoom, x, y, rotation } = camera.read(ecs_1.ComputedCamera);
            api.setAppState(Object.assign(Object.assign({}, api.getAppState()), { cameraZoom: zoom, cameraX: x, cameraY: y, cameraRotation: rotation }));
            if (zoom !== __classPrivateFieldGet(this, _ZoomLevel_zoomEvent, "f").detail.zoom) {
                __classPrivateFieldGet(this, _ZoomLevel_zoomEvent, "f").detail.zoom = zoom;
                api.element.dispatchEvent(__classPrivateFieldGet(this, _ZoomLevel_zoomEvent, "f"));
            }
        });
    }
}
exports.ZoomLevel = ZoomLevel;
_ZoomLevel_zoomEvent = new WeakMap();
//# sourceMappingURL=ZoomLevel.js.map